//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------

//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall Unit1::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------

__fastcall ShowPicThread::ShowPicThread(bool CreateSuspended)
        : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------
void __fastcall ShowPicThread::Execute()
{
        //---- Place thread code here ----
while (! Terminated){
  TSearchRec sr;
  TListItem *ListItem;
  int iPicCount=0;

  frmVirtualLView->ImageList1->Clear();
  frmVirtualLView->LstViewPicture->Items->Clear();

  if ( !FindFirst(FPath+"\\*.jpg",faAnyFile, sr) )
     {
      do
        {
         TJPEGImage *PicJpg   = new TJPEGImage();
         try
            {
             PicJpg->LoadFromFile(FPath+"\\"+sr.Name);
            }
         catch(...)
            {
             ShowMessage(FPath+"\\"+sr.Name);
            }
         Graphics::TBitmap *DestBmp   = new Graphics::TBitmap();
         float JpgWidth = PicJpg->Width;
         float JpgHeight = PicJpg->Height;
         DestBmp->Width=PicWidth;
         DestBmp->Height=PicHeight;
         if ((JpgWidth >= DestBmp->Width ) || (JpgHeight >= DestBmp->Height))
         {
                if (PicHeight >= PicWidth)
                {
                        float CompressRatio = JpgWidth / DestBmp->Width;
                        JpgWidth = JpgWidth / CompressRatio;
                        JpgHeight = JpgHeight / CompressRatio;
                        DestBmp->Canvas->StretchDraw(Rect(1,(PicHeight-JpgHeight)/2,JpgWidth,JpgHeight+(PicHeight-JpgHeight)/2),PicJpg);
                }
                else
                {
                        float CompressRatio = JpgHeight / DestBmp->Height;
                        JpgWidth = JpgWidth / CompressRatio;
                        JpgHeight = JpgHeight / CompressRatio;
                        DestBmp->Canvas->StretchDraw(Rect((PicWidth-JpgWidth)/2,1,JpgWidth+(PicWidth-JpgWidth)/2,JpgHeight),PicJpg);
                }
         }
         ListItem = frmVirtualLView->LstViewPicture->Items->Add();
         ListItem->Caption = sr.Name;

         ListItem->ImageIndex = frmVirtualLView->ImageList1->Add(DestBmp,NULL);
//         PicBmp->SaveToFile(AppDir+"\\back\\"+sr.Name);

         delete PicJpg;
         delete DestBmp;

//         StatusBar1->Panels->Items[0]->Text = "Total : "+IntToStr(++iPicCount)+" Jpeg.";
         Application->ProcessMessages();
        }
      while ((!FindNext(sr)) && (!bCloseForm));

      FindClose(sr);
    }
    }

}
//---------------------------------------------------------------------------

